#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include <string.h>
#include <string>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "global.h"

#include "processor.h"
#include "chains.h"
#include "ipchains.h"

#define MAXPATHLEN 1024

// 'static' widgets we want to keep track of
GtkWidget* text_dialog=NULL;
GtkWidget* fileselection=NULL;
char*      filemode=NULL;
char       currentFileName[MAXPATHLEN]="";

void
on_new_file_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	strcpy(currentFileName,"");
	chains_init();
}


void
on_open_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	filemode="open";
	if(!fileselection)
		fileselection = create_fileselection();
	gtk_widget_show (fileselection);	
}


void
on_save_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	if( strlen(currentFileName)==0 )
		on_save_as_activate(menuitem,user_data);
	else
		;// call the function to save as this file
}


void
on_save_as_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	filemode="save";
	if(!fileselection)
		fileselection = create_fileselection();
	gtk_widget_show (fileselection);	
}


void
on_exit_app_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	gtk_exit(0);
}


void
on_cut_activate                        (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_copy_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_paste_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_clear_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_properties_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_tools_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_sotck_rule_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_script_druid_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_preferences_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_about_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	GtkWidget *about_dialog;
	about_dialog = create_about_dialog ();
  gtk_widget_show (about_dialog);
}


void
on_button_new_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
	strcpy(currentFileName,"");
	chains_init();
}


void
on_button_open_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	filemode="open";
	if(!fileselection)
		fileselection = create_fileselection();
	gtk_widget_show (fileselection);	
}


void
on_button_save_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	if( strlen(currentFileName)==0 ){
		filemode="save";
		if(!fileselection)
			fileselection = create_fileselection();
		gtk_widget_show (fileselection);
	}else
		;// call the function to save as this file
}



void
on_rule_type_entry_changed             (GtkEditable     *editable,
                                        gpointer         user_data)
{
	
}


void
on_stock_rule_list_select_child        (GtkList         *list,
                                        GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_rule_update_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_rule_cancel_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_rule_edit_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_rule_become_stock_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_rule_tree_selection_changed         (GtkTree         *tree,
                                        gpointer         user_data)
{
	gchar* name;
	if( !tree ) return;
	GList *selection = GTK_TREE(tree)->selection;
	if( !selection ) return;
	GtkLabel *label = GTK_LABEL(GTK_BIN(selection->data)->child);
	gtk_label_get(label,&name);
	printf("---\nselected: '%s'\n",(char*)name);
	
	chains_handle_selection( label );
}


void
on_rule_prot_notebook_switch_page      (GtkNotebook     *notebook,
                                        GtkNotebookPage *page,
                                        gint             page_num,
                                        gpointer         user_data)
{

}


void
on_rule_frag_on_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	
}


void
on_rule_jump_entry_changed                (GtkEditable     *editable,
                                        gpointer         user_data)
{
	
}


void
on_button_add_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
	printf("defaults...\n");
	default_display();
}


void
on_button_remove_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_button_edit_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_button_stock_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
	if( !text_dialog ){
		text_dialog = create_text_dialog();
		lookup_text_dialog( text_dialog );
	}
	gtk_widget_show( text_dialog );
}


void
on_button_druid_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_button_stats_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_file_ok_button_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_widget_hide(fileselection);
	
	gchar* filename =
		gtk_file_selection_get_filename( GTK_FILE_SELECTION(fileselection) );

	do_file_action( filemode, filename );

}


void
on_file_cancel_button_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_widget_hide(fileselection);
}



void
on_gfirewall_destroy                   (GtkObject       *object,
                                        gpointer         user_data)
{
	gtk_exit(0);
}


void
on_rule_stock_dotdotdot_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_rule_prot_any_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

}


void
on_rule_icmp_type_entry_changed        (GtkEditable     *editable,
                                        gpointer         user_data)
{

}


void
on_rule_netlink_on_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

}


void
on_text_dialog_ok_button_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
	on_text_dialog_apply_button_clicked(button,user_data);
	gtk_widget_hide( text_dialog );
}


void
on_text_dialog_apply_button_clicked    (GtkButton       *button,
                                        gpointer         user_data)
{
	gchar* ptr;
	ptr = gtk_entry_get_text( GTK_ENTRY(text_dialog_entry) );
	
	printf("# %s\n",ptr);
	rule_to_display("test rule", string(ptr));
}


void
on_text_dialog_cancel_button_clicked   (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_widget_hide( text_dialog );
}




/*
rule_tree=widget;
	
	// just some hardcoded entries...
	{
		int i;
		GtkWidget* item;
		GtkWidget* subtree;
		GtkWidget* subitem;
		
		item = gtk_tree_item_new_with_label("input");
		gtk_tree_append(GTK_TREE(widget), item);
		gtk_widget_show(item);
		
		subtree = gtk_tree_new();
		gtk_tree_item_set_subtree( GTK_TREE_ITEM(item), subtree );
		for(i=0;i<2;i++){
			subitem = gtk_tree_item_new_with_label("some input chain");
			gtk_tree_append( GTK_TREE(subtree), subitem );
			gtk_widget_show(subitem);
		}
		
		item = gtk_tree_item_new_with_label("output");
		gtk_tree_append(GTK_TREE(widget), item);
		gtk_widget_show(item);
		
		subtree = gtk_tree_new();
		gtk_tree_item_set_subtree( GTK_TREE_ITEM(item), subtree );
		for(i=0;i<2;i++){
			subitem = gtk_tree_item_new_with_label("some output chain");
			gtk_tree_append( GTK_TREE(subtree), subitem );
			gtk_widget_show(subitem);
		}
		
		item = gtk_tree_item_new_with_label("forward");
		gtk_tree_append(GTK_TREE(widget), item);
		gtk_widget_show(item);
		
		subtree = gtk_tree_new();
		gtk_tree_item_set_subtree( GTK_TREE_ITEM(item), subtree );
		for(i=0;i<2;i++){
			subitem = gtk_tree_item_new_with_label("some masq chain");
			gtk_tree_append( GTK_TREE(subtree), subitem );
			gtk_widget_show(subitem);
		}
	}
*/

/****************************************************************************/

void
on_rule_notebook_switch_page           (GtkNotebook     *notebook,
                                        GtkNotebookPage *page,
                                        gint             page_num,
                                        gpointer         user_data)
{

}


void
on_import_chains_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	import_ipchains();
}


void
on_button_import_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
	import_ipchains();	
}


void
on_export_chains_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	export_ipchains();	
}


void
on_button_export_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
	export_ipchains();	
}


