/*
 * this file defines the communication done with ipchains
 * 
 */


#include <unistd.h>
#include <sys/types.h>
#include <gtk/gtk.h>
#include <unistd.h>

#include "interface.h"
#include "support.h"
#include "global.h"
#include "ipchains.h"
#include "chains.h"


/* used for reading ipchains list and using it for internal display */
bool import_ipchains(void)
{
	uid_t uid  = getuid();
	uid_t euid = geteuid();
	
	if( uid && euid ){
		gnome_error_dialog_parented("You do not have root permissions.",gfirewall_window);
		return false;
	}
	
	// open a pipe to capture the ipchains output
	int fd[2];
	if( !pipe(fd) ){
		
		// now fork a child process
		int child = fork();
		if( child>=0 ){
			
			if( child==0 ){
				// child process
				dup2(fd[1],STDOUT_FILENO);
				close(fd[0]);
				close(fd[1]);
				
				execl("/sbin/ipchains-save",NULL);
				perror("The exec failed.");
				
				exit(0);
			}
			
			// parent process
			close(fd[1]);
			
			// import the data...
			bool ret = chains_load_from_file( fd[0] );
			
			close(fd[0]);
			
			return ret;
		}
	}
	
	gnome_error_dialog_parented("Failed to complete the load process.",gfirewall_window);
	return false;
}

/* used for writing out the internal ipchains to the system */
bool export_ipchains(void)
{
	return false;
}

